<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeDirectDepositList StructType
 * @subpackage Structs
 */
class EmployeeDirectDepositList extends AbstractStructBase
{
    /**
     * The employeeDirectDeposit
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EmployeeDirectDeposit[]
     */
    public $employeeDirectDeposit;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for EmployeeDirectDepositList
     * @uses EmployeeDirectDepositList::setEmployeeDirectDeposit()
     * @uses EmployeeDirectDepositList::setReplaceAll()
     * @param \StructType\EmployeeDirectDeposit[] $employeeDirectDeposit
     * @param bool $replaceAll
     */
    public function __construct(array $employeeDirectDeposit = array(), $replaceAll = true)
    {
        $this
            ->setEmployeeDirectDeposit($employeeDirectDeposit)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get employeeDirectDeposit value
     * @return \StructType\EmployeeDirectDeposit[]|null
     */
    public function getEmployeeDirectDeposit()
    {
        return $this->employeeDirectDeposit;
    }
    /**
     * This method is responsible for validating the values passed to the setEmployeeDirectDeposit method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEmployeeDirectDeposit method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEmployeeDirectDepositForArrayConstraintsFromSetEmployeeDirectDeposit(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $employeeDirectDepositListEmployeeDirectDepositItem) {
            // validation for constraint: itemType
            if (!$employeeDirectDepositListEmployeeDirectDepositItem instanceof \StructType\EmployeeDirectDeposit) {
                $invalidValues[] = is_object($employeeDirectDepositListEmployeeDirectDepositItem) ? get_class($employeeDirectDepositListEmployeeDirectDepositItem) : sprintf('%s(%s)', gettype($employeeDirectDepositListEmployeeDirectDepositItem), var_export($employeeDirectDepositListEmployeeDirectDepositItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The employeeDirectDeposit property can only contain items of type \StructType\EmployeeDirectDeposit, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set employeeDirectDeposit value
     * @throws \InvalidArgumentException
     * @param \StructType\EmployeeDirectDeposit[] $employeeDirectDeposit
     * @return \StructType\EmployeeDirectDepositList
     */
    public function setEmployeeDirectDeposit(array $employeeDirectDeposit = array())
    {
        // validation for constraint: array
        if ('' !== ($employeeDirectDepositArrayErrorMessage = self::validateEmployeeDirectDepositForArrayConstraintsFromSetEmployeeDirectDeposit($employeeDirectDeposit))) {
            throw new \InvalidArgumentException($employeeDirectDepositArrayErrorMessage, __LINE__);
        }
        $this->employeeDirectDeposit = $employeeDirectDeposit;
        return $this;
    }
    /**
     * Add item to employeeDirectDeposit value
     * @throws \InvalidArgumentException
     * @param \StructType\EmployeeDirectDeposit $item
     * @return \StructType\EmployeeDirectDepositList
     */
    public function addToEmployeeDirectDeposit(\StructType\EmployeeDirectDeposit $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EmployeeDirectDeposit) {
            throw new \InvalidArgumentException(sprintf('The employeeDirectDeposit property can only contain items of type \StructType\EmployeeDirectDeposit, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->employeeDirectDeposit[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\EmployeeDirectDepositList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
